import QtQuick 1.1
import QtWebKit 1.0
import "quickshow"
//import "resources/qtminivan"

Presentation {
    id: root
//    width: 1024
//    height: 768
    width: 1300
    height: 1000

    ImageSlide {
        source: "resources/cover.png"
        title: "Lighthouse: Uma introdução"
        authors: "Anselmo L. S. Melo"
        date: "1 de Dezembro de 2011"
    }


    ///### FIXME!
    RegularSlide {
        title: "Agenda"

        content: [
            "Origens",
            "Idéia! (velha ortografia++)",
            "codename: Lighthouse",
            "QPA",
            "Exemplos"
        ]
    }

//    DividerSlide {
//        centeredText: "Um pouco sobre servidor gráfico"
//    }

//    RegularSlide {
//        title: "Servidor Gráfico: X11"
//        CodeSection {
//            anchors.left: parent.left
//            Image {
//                anchors.centerIn: parent
//                source: "resources/x_client_sever.png"
//            }
//        }
//    }

//    RegularSlide {
//        Image {
//            anchors.centerIn: parent
//            source: "resources/xlib.png"
//        }
//    }

    RegularSlide {
        title: "Origens..."
        content: [
            "Meados de 2009: refatorar o código do Qt for Embedded",
            "Reduzir a dependência do QWS",
        ]
    }

    RegularSlide {
        title: "Qt for Embedded? QWS?"
        content: [
            "Qt for Embedded Linux: framebuffer (i.e. sem Xorg)",
            "QWS: Q Windowing System - client/server",
            "QWS nem sempre é relevante"
        ]
    }

    RegularSlide {
        centeredText: "Anos de código legado acumulado => a tarefa demonstrou-se bem maior do que o esperado."
    }
    DividerSlide {
        centeredText: "Idéia!"
    }

    RegularSlide {
        fontSize: 40
        slideTextColor: "#ffd600"
        centeredText: "\"Quão difícil seria remover todo o código específico de plataformas e ter um novo port compilável?\""
    }

    RegularSlide {
        title: "A infra já estava lá"
        content: [
            "raster paint engine + Alien",
            "\"Uma janela fullscreen no framebuffer não deve ser difícil\""
        ]
    }

    DividerSlide {
        centeredText: "Pause!"
    }

    RegularSlide {
        title: "Raster Engine?"
        content: [
            "Surgiu após fracassadas tentativas de usar GDI e GDI+",
            "Única <i>engine</i> que implementa todas funcionalidades do QPainter",
            "Tudo feito em software"
        ]
    }

    RegularSlide {
        title: "Alien?"

        Image {
            anchors.centerIn: parent
            source: "resources/varginha.jpg"
        }
    }

    RegularSlide {
        title: "Alien Widgets"

        Text {
            id: alienSlideText
            anchors.top: parent.top
            anchors.horizontalCenter: parent.horizontalCenter
            color: "white"
                font.pixelSize: 30
                text: "Qt >= 4.4"
        }

        Row {
            spacing: 20
            anchors.centerIn: parent
            anchors.top: alienSlideText.bottom
            Image {
                source: "resources/alien1.png"
            }
            Rectangle {
                color: "white"
                width: 5
                height: parent.height
            }

            Image {
                source: "resources/alien2.png"
            }
        }
    }

    DividerSlide {
        centeredText: "Play!"
    }

    RegularSlide {
        title: "Implementar a idéia não demorou tanto"
        centeredText: "Uma semana depois: compila!"
    }

    RegularSlide {
        title: "codename: Lighthouse"
        content: [
            "\"not to be confused with a very early preview of Qt for S60 that was used by about 5 people outside Nokia\"",
            "Q_WS_LITE",
            "Mote: Como tornar mais fácil suportar diferentes hw gráficos?"
        ]
    }

    RegularSlide {
        title: "Lighthouse"
        content: [
            "Mote: Como tornar mais fácil suportar diferentes hw gráficos?"
        ]
    }


    RegularSlide {
        title: "Quantas linhas de código?"
        content: [
            "QImage como display device: 147 linhas",
            "OpenVG backend: 288 linhas",
        ]
    }

    RegularSlide {
        title: "Input handling?"
        centeredText: "Hack inicial: métodos em QApplicationPrivate"
    }

    RegularSlide {
        title: "Danger! Danger!"
        content: [
            "QApplicstion<b>Private</b>",
            "Can of worms: QEventLoop e modal dialogs"
            // handler for an event doesn't return until any such dialogs have finished.
            //### IDEA: comments to generate speaker notes?
        ]
    }
    RegularSlide {
        title: "QWindowSystemInterface"
        centeredText: "Classe abstrata com interfaces para todos eventos do sistema de janelas"
    }

    RegularSlide {
        title: "Qt Platform Abstraction"
        centeredText: "2011: integrated, part of 4.8"
    }

    RegularSlide {
        title: "Criando um port simples"
        content: [
            "exemplo: src/plugins/platforms/minimal",
            "QPlatgormIntegrationPlugin",
            "QPlatformScreen",
            "QPlatformIntegration",
            "QWindowSurface"
        ]
    }

    RegularSlide {
        title: "Onde ficam as classes QPA?"
        content: [
            "Em src/gui/kernel",
            "qplatformclipboard_qpa.h",
            "qplatformcursor_qpa.h",
            "qplatformeventloopintegration_qpa.h",
            "qplatformglcontext_qpa.h",
            "qplatformintegrationplugin_qpa.h",
        ]
    }

    RegularSlide {
        title: "E tem mais..."
        content: [
            "qplatformintegration_qpa.h",
            "qplatformnativeinterface_qpa.h",
            "qplatformscreen_qpa.h",
            "qplatformwindowformat_qpa.h",
            "qplatformwindow_qpa.h",
        ]
    }

    RegularSlide {
        title: "sloccount diz..."
        content: [
            "qwidget_x11: 2,424",
            "qwidget_qpa: 671"
        ]
    }

    DividerSlide {
        centeredText: "Exemplos"
    }

    RegularSlide {
        title: "libCaca"

        Text {
            id: slideText
            anchors.top: parent.top
            anchors.horizontalCenter: parent.horizontalCenter
            color: "white"
            font.pixelSize: 30
            text: "\"output text instead of pixels\""
        }

        // Crashes with Qt 4.7.4 due to a undefined symbol in phonon =(
        // Works with 4.8
        WebView {
            anchors.centerIn: parent
            height: 320
            width: 440
            settings.javaEnabled: false
            html: "<iframe width=\"420\" height=\"315\" src=\"http://www.youtube.com/embed/ZJyF99uqSbY\" frameborder=\"0\"></iframe>"
        }
    }

    RegularSlide {
        title: "Qt for NaCl"

        Image {
            anchors.centerIn: parent
            source: "resources/nacl.png"
        }
    }

    RegularSlide {
        title: "Necessitas - Qt for Android"

        Image {
            anchors.centerIn: parent
            source: "resources/necessitas.png"
        }
    }

    RegularSlide {
        title: "UIKit lighthouse platform == Qt on iOS"

        WebView {
            anchors.centerIn: parent
            height: 320
            width: 440
            settings.javaEnabled: false
            html: "<iframe width=\"420\" height=\"315\" src=\"http://www.youtube.com/embed/glv_E3KOYuA\" frameborder=\"0\"></iframe>"
        }
    }

    RegularSlide {
        content: [
            "Qt-Wayland",
            "Qt 5"
        ]
    }

    RegularSlide {
        centeredText: "Perguntas?"
    }

    RegularSlide {
        centeredText: "Obrigado =)"
    }

    DividerSlide {
        centeredText: "[Off topic]"
    }

    RegularSlide {
        Rectangle {
            anchors.centerIn: parent
            width: 640
            height: 360
            clip: true
//            Main_640_360 {
//                anchors.fill: parent
//            }
        }
    }
}
